summaryrefslogtreecommitdiffstats
path: root/system/memkind
diff options
context:
space:
mode:
Diffstat (limited to 'system/memkind')
-rw-r--r--system/memkind/README11
-rw-r--r--system/memkind/changelog12
-rw-r--r--system/memkind/memkind.SlackBuild117
-rw-r--r--system/memkind/memkind.info10
-rw-r--r--system/memkind/slack-desc19
5 files changed, 169 insertions, 0 deletions
diff --git a/system/memkind/README b/system/memkind/README
new file mode 100644
index 0000000000..f0400d1c0b
--- /dev/null
+++ b/system/memkind/README
@@ -0,0 +1,11 @@
+Memkind helps to fully utilize various kinds of
+memory available in the system,including DRAM,NVDIMM
+and HBM, mostly by adding one additional argument
+destination kind of memory to standard malloc calls.
+
+It also offers a transparent mode that allows memory
+tiering without any modification to the existing app,
+memory kinds based on file-backed memory on specified
+device or area supplied by the user, and much more.
+
+hwloc >=2.3.0 is an optional dependency.
diff --git a/system/memkind/changelog b/system/memkind/changelog
new file mode 100644
index 0000000000..83f8e060ab
--- /dev/null
+++ b/system/memkind/changelog
@@ -0,0 +1,12 @@
+Changelog for memkind SlackBuild Script
+--------------------------------------------------------------------
+
+03/09/2022:
+
+Added to slackbuilds.org
+
+15/05/2023:
+
+Updated to version 1.13.0
+From this build onwards it will only build
+on x86_64 platform only.
diff --git a/system/memkind/memkind.SlackBuild b/system/memkind/memkind.SlackBuild
new file mode 100644
index 0000000000..1c5c9d517c
--- /dev/null
+++ b/system/memkind/memkind.SlackBuild
@@ -0,0 +1,117 @@
+#!/bin/bash
+
+# Slackware build script for memkind
+
+# Copyright 2022-2023 Vijay Marcel
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PRGNAM=memkind
+VERSION=${VERSION:-1.14.0}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+PKGTYPE=${PKGTYPE:-tgz}
+sys_arch=${sys_arch:-$(uname -m)}
+
+case "$sys_arch" in
+ x86_64) export ARCH=x86_64 ;;
+ *) echo "This program will not build on $sys_arch platform" && exit 1 ;;
+esac
+
+# If the variable PRINT_PACKAGE_NAME is set, then this script will report what
+# the name of the created package would be, and then exit. This information
+# could be useful to other scripts.
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-march=x86-64 -mtune=generic -pipe -O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ echo "This program will not build on $sys_arch platform" && exit 1
+fi
+
+set -e
+trap 'echo "$0 FAILED at line $LINENO!" | tee -a $OUTPUT/error-${PRGNAM}.log' ERR
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/$PRGNAM-$VERSION.tar.gz
+cd $PRGNAM-$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+CFLAGS="$SLKCFLAGS" \
+CXXFLAGS="$SLKCFLAGS" \
+./autogen.sh
+
+./configure \
+ --prefix=/usr \
+ --libdir=/usr/lib${LIBDIRSUFFIX} \
+ --bindir=/usr/bin \
+ --sysconfdir=/etc \
+ --localstatedir=/var \
+ --mandir=/usr/man \
+ --docdir=/usr/doc/$PRGNAM-$VERSION \
+ --enable-tls \
+ --enable-decorators \
+ --enable-gcov \
+ --enable-secure \
+ --enable-memkind-initial-exec-tls \
+ --enable-daxctl \
+ --build=$ARCH-slackware-linux
+
+make
+make install DESTDIR=$PKG
+
+rm -f $PKG/{,usr/}lib${LIBDIRSUFFIX}/*.la
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+find $PKG/usr/man -type f -exec gzip -9 {} \;
+for i in $( find $PKG/usr/man -type l ) ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
+
+find $PKG -name perllocal.pod \
+ -o -name ".packlist" -o -name "*.bs" \
+ | xargs rm -f
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a NEWS README COPYING AUTHORS ChangeLog VERSION $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE
diff --git a/system/memkind/memkind.info b/system/memkind/memkind.info
new file mode 100644
index 0000000000..9405289355
--- /dev/null
+++ b/system/memkind/memkind.info
@@ -0,0 +1,10 @@
+PRGNAM="memkind"
+VERSION="1.14.0"
+HOMEPAGE="https://pmem.io/memkind/"
+DOWNLOAD="UNSUPPORTED"
+MD5SUM=""
+DOWNLOAD_x86_64="https://github.com/memkind/memkind/archive/v1.14.0/memkind-1.14.0.tar.gz"
+MD5SUM_x86_64="252ee2458d7830774ee0ac003f2140a1"
+REQUIRES="numactl pandoc-bin"
+MAINTAINER="Vijay Marcel"
+EMAIL="vijaymarcel@outlook.com"
diff --git a/system/memkind/slack-desc b/system/memkind/slack-desc
new file mode 100644
index 0000000000..1a7ed41296
--- /dev/null
+++ b/system/memkind/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+memkind: memkind (General Purpose Allocator on top of Jemalloc)
+memkind:
+memkind: Memkind helps to fully utilize various kinds of
+memkind: memory available in the system,including DRAM,NVDIMM
+memkind: and HBM, mostly by adding one additional argument
+memkind: destination kind of memory to standard malloc calls.
+memkind:
+memkind: Homepage:https://pmem.io/memkind
+memkind:
+memkind:
+memkind: